// ArmDisassembler.h: interface for the CArmDisassembler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ARMDISASSEMBLER_H__25329DF5_C147_11D4_B292_00A0246BA40A__INCLUDED_)
#define AFX_ARMDISASSEMBLER_H__25329DF5_C147_11D4_B292_00A0246BA40A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TarmacGlobals.h"

class CArmDisassembler  
{
//private:


public:
	static CString disassemble(uint32 address, uint32 instruction);
	CArmDisassembler();
	virtual ~CArmDisassembler();

private:
	static CString decodeRegisterList(uint32 instruction);
	static CString decodeSingleDataSwap(uint32 address, uint32 instruction);
	static CString decodeMultiply(uint32 address, uint32 instruction);
	static CString decodeConditionCode(uint32 instruction);
	static CString decodeSoftwareInterrupt(uint32 address, uint32 instruction);
	static CString decodeCoProRegTransferOrDataOperation(uint32 address, uint32 instruction);
	static CString decodeCoProDTPostIndex(uint32 address, uint32 instruction);
	static CString decodeCoProDTPreIndex(uint32 address, uint32 instruction);
	static CString decodeBranchWithLink(uint32 address, uint32 instruction);
	static CString decodeBranch(uint32 address, uint32 instruction);
	static CString decodeBlockDTPreIndex(uint32 address, uint32 instruction);
	static CString decodeBlockDTPostIndex(uint32 address, uint32 instruction);
	static CString decodeSingleDTRegOffsetPreIndex(uint32 address, uint32 instruction);
	static CString decodeSingleDTRegOffsetPostIndex(uint32 address, uint32 instruction);
	static CString decodeSingleDTImmOffsetPreIndex(uint32 address, uint32 instruction);
	static CString decodeSingleDTImmOffsetPostIndex(uint32 address, uint32 instruction);
	static CString decodeDataProcessing(uint32 address, uint32 instruction);
	static CString decodeSingleDataSwapOrDataProcessing(uint32 address, uint32 instruction);
	static CString decodeMultiplyOrDataProcessing(uint32 address, uint32 instruction);					
};





//typedef CString (CArmDisassembler::*DecodeFunction)(uint32 address, uint32 instruction);

#endif // !defined(AFX_ARMDISASSEMBLER_H__25329DF5_C147_11D4_B292_00A0246BA40A__INCLUDED_)
