// Optimiser.h: interface for the COptimiser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPTIMISER_H__68AD7A4D_D521_43F7_A641_B22AB22E4C23__INCLUDED_)
#define AFX_OPTIMISER_H__68AD7A4D_D521_43F7_A641_B22AB22E4C23__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LinkedList.h"
#include "Profiler.h"
#include "Generator.h"
#include "CodeCache.h"

class CGenerator;

class COptimiser  
{
public:
	void setCodeCache(CCodeCache* aCodeCache);
	void optimise(CLinkedList* chunk);
	COptimiser();
	virtual ~COptimiser();

private:
	CGenerator* generator;
	void removeRedundantFlagCalculations();
	Armlet** chunk;
	int totalArmlets;
	void identifyLeaders();

	CStdioFile armletReportFile;

};

#endif // !defined(AFX_OPTIMISER_H__68AD7A4D_D521_43F7_A641_B22AB22E4C23__INCLUDED_)
